<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

class MotiEvolContController extends TeknisaCrud
{
    protected $dataSourceName = 'motievolcont_perfiloperador';
    protected $parameterBagColumns = array('P_NRORG','P_CDOPERADOR');
    protected $connection;
    protected $motiEvolService;
    protected $zhFileUploader;
    
    public function __construct($crudService, $parameterBag, EntityManager $entityManager, $motiEvolService, $zhFileUploader) {
        $this->connection = $entityManager->getConnection();
        $this->motiEvolService = $motiEvolService;
        $this->zhFileUploader = $zhFileUploader;
    }

    public function removeMotiEvolAttachment(Row $request, Response $response) {
        $row = $request->getRow();
        
        try {
            $this->connection->beginTransaction();
            
            $this->motiEvolService->removeAttachment($row);
            $this->zhFileUploader->deleteFile($row["DSCAMINHOANEXOPADRAO"]);
            
            $this->connection->commit();
            $response->addDataSet(new DataSet('DADOS', array('REMOVED' => true)));
        } catch(\Exception $e) {
            $this->connection->rollBack();
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
        
       
    }
}