<?php
/**
 * Created by PhpStorm.
 * User: pedrobaptista
 * Date: 10/06/2015
 * Time: 11:31
 */

namespace Teknisa\CRM\Controller;


use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\CRM\Service\SecurityService;
use Zeedhi\Framework\DTO\Response\Method;
use Zeedhi\Framework\DataSource\DataSet;

class Session {
    // const SET_FORMS_URL = "https://crm.pebbian.com/teknisa/service.php";
    const SET_FORMS_URL = "http://localhost:9090/crm/service.php";

    protected  $entityManager;
    protected $setformsUrlConnection;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function setSetformsUrlConnection($setformsUrlConnection){
        $this->setformsUrlConnection = $setformsUrlConnection;
    }

    public function startSession(Row $request, Response $response){
        session_write_close();
        
        $service = new SecurityService($this->entityManager);
        $row = $request->getRow();

        $data  = array(
            "objectId" => "LoginData:LoginData",
            "action" => "getLoginData",
            "dataset" => "[{_ID:,_STATE:,_CHECKED:,ACESSO:,SENHA:}]",
            "args[id]" => $row["TOKEN"],
            "args[tabId]" => "LoginData:LoginData"
        );

        $dataStr = http_build_query($data);

        $header = array();
        $header[] = 'Content-Type: application/x-www-form-urlencoded; charset=UTF-8';
        $header[] = 'Content-Length: '.strlen($dataStr);

        $ch = curl_init($this->setformsUrlConnection);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        //curl_setopt($ch, CURLOPT_URL, self::SET_FORMS_URL);
        //curl_setopt($ch, CURLOPT_URL, $this->setformsUrlConnection);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $dataStr);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        $result = curl_exec($ch);

        curl_close($ch);

        $data = json_decode($result, true);

        $session = new \Zeedhi\Framework\Session\Session();
        $response->addMethod(new Method('RESULT', $result));
        if($data['extras'] && array_key_exists('aborted',$data['extras']) !== true)
        {
            if ($service->validateOperador($data['extras'][":"]['CDOPERADOR']) === false) {
                $response->addMessage(new Message("Operador Inválido"));
            }

            $nrGroupCtlAcess = $service->getNrGroupCtlAcess();
            $nmoperador      = $service->getNmoperador();
            $nrParcNegocio   = $service->getNrParcNegocio();
            $cdfilial        = $service->getCdfilial();

            $session->set('operator', $data['extras'][":"]['CDOPERADOR']);
            $session->set('nrorg', $data['extras'][":"]['NRORG']);
            $session->set('nmoperador', $nmoperador);
            $session->set('nrGroupCtlAcess', $nrGroupCtlAcess);
            $session->set('nrParcNegocio', $nrParcNegocio);
            $session->set('cdfilial', $cdfilial);

            $response->addMethod(new Method('setLocalVar', array('CDOPERADOR', $data['extras'][":"]['CDOPERADOR'])));
            $response->addMethod(new Method('setLocalVar', array('NRORG', $data['extras'][":"]['NRORG'])));
            $response->addMethod(new Method('setLocalVar', array('CDSENHAOPER', $data['extras'][":"]['CDSENHAOPER'])));
            $response->addMethod(new Method('setLocalVar', array('CDFILIAL', $cdfilial)));
            $response->addMethod(new Method('setLocalVar', array('NMOPERADOR', $nmoperador)));

            $response->addDataSet(new DataSet('login', array($nrGroupCtlAcess)));

            // define nome do operador para o UserInfo do menu
            $response->addDataSet(new DataSet('userData', array('nmoperador' => $nmoperador)));
            $email = $data['extras'][":"]['DSEMAILOPER'];
            $senha = $data['extras'][":"]['CDSENHAOPER'];
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('operador', array("email" => $email, "senha" => $senha)));
        }
        else
        {
            $email = $data['extras'][":"]['DSEMAILOPER'];
            $senha = $data['extras'][":"]['CDSENHAOPER'];
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('operador', array("email" => $email, "senha" => $senha)));
            $response->addMethod(new Method('setLocalVar', array('CDOPERADOR', false)));
        }
    }
}