<?php
namespace Teknisa\CRM\Service;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class GeraTarefasParcRelacOperProcedure {
	
	protected $connection;
	
	public function __construct(Connection $connection) {
		
		$this->connection = $connection;
		
	}

	public function executeProcedure($row) {
		
		//$this->connection->beginTransaction();
		
		try{
			
			$tasksByIntervalProcedure = new StoredProcedure($this->connection, "GERA_TAREFAS_PARC_RELAC_OPER");
			
			$tasksByIntervalProcedure->addParam(new Param('V_TIPOPARCEIRO', Param::PARAM_INPUT, $row["TIPOPARCEIRO"]));
			$tasksByIntervalProcedure->addParam(new Param('V_DSFILACONTATO', Param::PARAM_INPUT, $row["DSFILACONTATO"]));
			$tasksByIntervalProcedure->addParam(new Param('V_DTINI', Param::PARAM_INPUT, $row["INTERVALO_DATA"]["start"]));
			$tasksByIntervalProcedure->addParam(new Param('V_DTFIM', Param::PARAM_INPUT, $row["INTERVALO_DATA"]["end"]));
			$tasksByIntervalProcedure->addParam(new Param('V_CODIGO_OPERADOR_LOGADO', Param::PARAM_INPUT, $row["CDOPERADOR"]));	
			$tasksByIntervalProcedure->addParam(new Param('V_NRORG', Param::PARAM_INPUT, $row["NRORG"]));
			
			$tasksByIntervalProcedure->execute();
			//$this->connection->commit();
			
			
		} catch(Exception $e){
			
			$this->connection->rollBack();
			throw $e;
			
		}
	}
	
}